Overview | Package | Class | Use | Tree | Deprecated | Index | Help
|  | BEA Systems, Inc.
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

WebLogic Server 8.1 API Reference

## weblogic.apache.xml.serialize
Class BaseMarkupSerializer

    java.lang.Object
      |
      +--weblogic.apache.xml.serialize.BaseMarkupSerializer

Direct Known Subclasses:
  HTMLSerializer, TextSerializer, XMLSerializer

public abstract class BaseMarkupSerializer
extends java.lang.Object
implements org.xml.sax.ContentHandler, org.xml.sax.DocumentHandler, org.xml.sax.ext.LexicalHandler, org.xml.sax.DTDHandler, org.xml.sax.ext.DeclHandler, DOMSerializer, Serializer

Base class for a serializer supporting both DOM and SAX pretty serializing of XML/HTML/XHTML documents. Derives classes perform the method-specific serializing, this class provides the common serializing mechanisms.

The serializer must be initialized with the proper writer and output format before it can be used by calling `setOutputCharStream(java.io.Writer)` or `setOutputByteStream(java.io.OutputStream)` for the writer and `setOutputFormat(weblogic.apache.xml.serialize.OutputFormat)` for the output format.

The serializer can be reused any number of times, but cannot be used concurrently by two threads.

If an output stream is used, the encoding is taken from the output format (defaults to `UTF-8`). If a writer is used, make sure the writer uses the same encoding (if applies) as specified in the output format.

The serializer supports both DOM and SAX. DOM serializing is done by calling `serialize(Document)` and SAX serializing is done by firing SAX events and using the serializer as a document handler. This also applies to derived class.

If an I/O exception occurs while serializing, the serializer will not throw an exception directly, but only throw it at the end of serializing (either DOM or SAX's `DocumentHandler.endDocument()`.

For elements that are not specified as whitespace preserving, the serializer will potentially break long text lines at space boundaries, indent lines, and serialize elements on separate lines. Line terminators will be regarded as spaces, and spaces at beginning of line will be stripped.

When indenting, the serializer is capable of detecting seemingly element content, and serializing these elements indented on separate lines. An element is serialized indented when it is the first or last child of an element, or immediate following or preceding another element.

See Also:
  `Serializer`, `DOMSerializer`

Field Summary
`protected java.lang.String` | `_docTypePublicId` The system identifier of the document type, if known.
`protected java.lang.String` | `_docTypeSystemId` The system identifier of the document type, if known.
`protected EncodingInfo` | `_encodingInfo`
`protected OutputFormat` | `_format` The output format associated with this serializer.
`protected boolean` | `_indenting` True if indenting printer.
`protected java.util.Hashtable` | `_prefixes` Association between namespace URIs (keys) and prefixes (values).
`protected Printer` | `_printer` The printer used for printing text parts.
`protected boolean` | `_started` If the document has been started (header serialized), this flag is set to true so it's not started twice.
`protected DOMErrorImpl` | `fDOMError`
`protected org.apache.xerces.dom3.DOMErrorHandler` | `fDOMErrorHandler`
`protected org.w3c.dom.ls.DOMWriterFilter` | `fDOMFilter`
`protected java.util.Hashtable` | `fFeatures`
`protected java.lang.StringBuffer` | `fStrBuffer` Temporary buffer to store character data

Constructor Summary
`protected` | `BaseMarkupSerializer(OutputFormat format)` Protected constructor can only be used by derived class.

Method Summary
`org.xml.sax.ContentHandler` | `asContentHandler()`
`org.xml.sax.DocumentHandler` | `asDocumentHandler()`
`DOMSerializer` | `asDOMSerializer()`
`void` | `attributeDecl(java.lang.String eName, java.lang.String aName, java.lang.String type, java.lang.String valueDefault, java.lang.String value)`
`void` | `characters(char[] chars, int start, int length)`
`protected void` | `characters(java.lang.String text)` Called to print the text contents in the prevailing element format.
`void` | `comment(char[] chars, int start, int length)`
`void` | `comment(java.lang.String text)`
`protected ElementState` | `content()` Must be called by a method about to print any type of content.
`void` | `elementDecl(java.lang.String name, java.lang.String model)`
`void` | `endCDATA()`
`void` | `endDocument()` Called at the end of the document to wrap it up.
`void` | `endDTD()`
`void` | `endEntity(java.lang.String name)`
`void` | `endNonEscaping()`
`void` | `endPrefixMapping(java.lang.String prefix)`
`void` | `endPreserving()`
`protected ElementState` | `enterElementState(java.lang.String namespaceURI, java.lang.String localName, java.lang.String rawName, boolean preserveSpace)` Enter a new element state for the specified element.
`void` | `externalEntityDecl(java.lang.String name, java.lang.String publicId, java.lang.String systemId)`
`protected void` | `fatalError(java.lang.String message)`
`protected ElementState` | `getElementState()` Return the state of the current element.
`protected abstract java.lang.String` | `getEntityRef(int ch)` Returns the suitable entity reference for this character value, or null if no such entity exists.
`protected java.lang.String` | `getPrefix(java.lang.String namespaceURI)` Returns the namespace prefix for the specified URI.
`void` | `ignorableWhitespace(char[] chars, int start, int length)`
`void` | `internalEntityDecl(java.lang.String name, java.lang.String value)`
`protected boolean` | `isDocumentState()` Returns true if in the state of the document.
`protected ElementState` | `leaveElementState()` Leave the current element state and return to the state of the parent element.
`protected org.apache.xerces.dom3.DOMError` | `modifyDOMError(java.lang.String message, short severity, org.w3c.dom.Node node)` The method modifies global DOM error object
`void` | `notationDecl(java.lang.String name, java.lang.String publicId, java.lang.String systemId)`
`protected void` | `prepare()`
`protected void` | `printCDATAText(java.lang.String text)`
`protected void` | `printDoctypeURL(java.lang.String url)` Print a document type public or system identifier URL.
`protected void` | `printEscaped(int ch)`
`protected void` | `printEscaped(java.lang.String source)` Escapes a string so it may be printed as text content or attribute value.
`protected void` | `printText(char[] chars, int start, int length, boolean preserveSpace, boolean unescaped)` Called to print additional text with whitespace handling.
`protected void` | `printText(java.lang.String text, boolean preserveSpace, boolean unescaped)`
`void` | `processingInstruction(java.lang.String target, java.lang.String code)`
`void` | `processingInstructionIO(java.lang.String target, java.lang.String code)`
`boolean` | `reset()`
`void` | `serialize(org.w3c.dom.Document doc)` Serializes the DOM document using the previously specified writer and output format.
`void` | `serialize(org.w3c.dom.DocumentFragment frag)` Serializes the DOM document fragmnt using the previously specified writer and output format.
`void` | `serialize(org.w3c.dom.Element elem)` Serializes the DOM element using the previously specified writer and output format.
`protected abstract void` | `serializeElement(org.w3c.dom.Element elem)` Called to serializee the DOM element.
`protected void` | `serializeNode(org.w3c.dom.Node node)` Serialize the DOM node.
`protected void` | `serializePreRoot()` Comments and PIs cannot be serialized before the root element, because the root element serializes the document type, which generally comes first.
`void` | `setDocumentLocator(org.xml.sax.Locator locator)`
`void` | `setOutputByteStream(java.io.OutputStream output)`
`void` | `setOutputCharStream(java.io.Writer writer)`
`void` | `setOutputFormat(OutputFormat format)`
`void` | `skippedEntity(java.lang.String name)`
`void` | `startCDATA()`
`void` | `startDocument()`
`void` | `startDTD(java.lang.String name, java.lang.String publicId, java.lang.String systemId)`
`void` | `startEntity(java.lang.String name)`
`void` | `startNonEscaping()`
`void` | `startPrefixMapping(java.lang.String prefix, java.lang.String uri)`
`void` | `startPreserving()`
`protected void` | `surrogates(int high, int low)`
`void` | `unparsedEntityDecl(java.lang.String name, java.lang.String publicId, java.lang.String systemId, java.lang.String notationName)`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### fFeatures

    protected java.util.Hashtable fFeatures

### fDOMErrorHandler

    protected org.apache.xerces.dom3.DOMErrorHandler fDOMErrorHandler

### fDOMError

    protected final DOMErrorImpl fDOMError

### fDOMFilter

    protected org.w3c.dom.ls.DOMWriterFilter fDOMFilter

### _encodingInfo

    protected EncodingInfo _encodingInfo

### _started

    protected boolean _started

  If the document has been started (header serialized), this flag is set to true so it's not started twice.

### _prefixes

    protected java.util.Hashtable _prefixes

  Association between namespace URIs (keys) and prefixes (values). Accumulated here prior to starting an element and placing this list in the element state.

### _docTypePublicId

    protected java.lang.String _docTypePublicId

  The system identifier of the document type, if known.

### _docTypeSystemId

    protected java.lang.String _docTypeSystemId

  The system identifier of the document type, if known.

### _format

    protected OutputFormat _format

  The output format associated with this serializer. This will never be a null reference. If no format was passed to the constructor, the default one for this document type will be used. The format object is never changed by the serializer.

### _printer

    protected Printer _printer

  The printer used for printing text parts.

### _indenting

    protected boolean _indenting

  True if indenting printer.

### fStrBuffer

    protected final java.lang.StringBuffer fStrBuffer

  Temporary buffer to store character data

Constructor Detail

### BaseMarkupSerializer

    protected BaseMarkupSerializer(OutputFormat format)

  Protected constructor can only be used by derived class. Must initialize the serializer before serializing any document, by calling `setOutputCharStream(java.io.Writer)` or `setOutputByteStream(java.io.OutputStream)` first

Method Detail

### asDocumentHandler

    public org.xml.sax.DocumentHandler asDocumentHandler()
                                                  throws java.io.IOException

  Specified by:
    asDocumentHandler in interface Serializer

### asContentHandler

    public org.xml.sax.ContentHandler asContentHandler()
                                                throws java.io.IOException

  Specified by:
    asContentHandler in interface Serializer

### asDOMSerializer

    public DOMSerializer asDOMSerializer()
                                  throws java.io.IOException

  Specified by:
    asDOMSerializer in interface Serializer

### setOutputByteStream

    public void setOutputByteStream(java.io.OutputStream output)

  Specified by:
    setOutputByteStream in interface Serializer

### setOutputCharStream

    public void setOutputCharStream(java.io.Writer writer)

  Specified by:
    setOutputCharStream in interface Serializer

### setOutputFormat

    public void setOutputFormat(OutputFormat format)

  Specified by:
    setOutputFormat in interface Serializer

### reset

    public boolean reset()

### prepare

    protected void prepare()
                    throws java.io.IOException

### serialize

    public void serialize(org.w3c.dom.Element elem)
                   throws java.io.IOException

  Serializes the DOM element using the previously specified writer and output format. Throws an exception only if an I/O exception occured while serializing.
  Specified by:
    serialize in interface DOMSerializer

  Parameters:
    `elem` - The element to serialize
  Throws:
    java.io.IOException - An I/O exception occured while serializing

### serialize

    public void serialize(org.w3c.dom.DocumentFragment frag)
                   throws java.io.IOException

  Serializes the DOM document fragmnt using the previously specified writer and output format. Throws an exception only if an I/O exception occured while serializing.
  Specified by:
    serialize in interface DOMSerializer

  Parameters:
    `elem` - The element to serialize
  Throws:
    java.io.IOException - An I/O exception occured while serializing

### serialize

    public void serialize(org.w3c.dom.Document doc)
                   throws java.io.IOException

  Serializes the DOM document using the previously specified writer and output format. Throws an exception only if an I/O exception occured while serializing.
  Specified by:
    serialize in interface DOMSerializer

  Parameters:
    `doc` - The document to serialize
  Throws:
    java.io.IOException - An I/O exception occured while serializing

### startDocument

    public void startDocument()
                       throws org.xml.sax.SAXException

  Specified by:
    startDocument in interface org.xml.sax.ContentHandler

### characters

    public void characters(char[] chars,
                           int start,
                           int length)
                    throws org.xml.sax.SAXException

  Specified by:
    characters in interface org.xml.sax.ContentHandler

### ignorableWhitespace

    public void ignorableWhitespace(char[] chars,
                                    int start,
                                    int length)
                             throws org.xml.sax.SAXException

  Specified by:
    ignorableWhitespace in interface org.xml.sax.ContentHandler

### processingInstruction

    public final void processingInstruction(java.lang.String target,
                                            java.lang.String code)
                                     throws org.xml.sax.SAXException

  Specified by:
    processingInstruction in interface org.xml.sax.ContentHandler

### processingInstructionIO

    public void processingInstructionIO(java.lang.String target,
                                        java.lang.String code)
                                 throws java.io.IOException

### comment

    public void comment(char[] chars,
                        int start,
                        int length)
                 throws org.xml.sax.SAXException

  Specified by:
    comment in interface org.xml.sax.ext.LexicalHandler

### comment

    public void comment(java.lang.String text)
                 throws java.io.IOException

### startCDATA

    public void startCDATA()

  Specified by:
    startCDATA in interface org.xml.sax.ext.LexicalHandler

### endCDATA

    public void endCDATA()

  Specified by:
    endCDATA in interface org.xml.sax.ext.LexicalHandler

### startNonEscaping

    public void startNonEscaping()

### endNonEscaping

    public void endNonEscaping()

### startPreserving

    public void startPreserving()

### endPreserving

    public void endPreserving()

### endDocument

    public void endDocument()
                     throws org.xml.sax.SAXException

  Called at the end of the document to wrap it up. Will flush the output stream and throw an exception if any I/O error occured while serializing.
  Specified by:
    endDocument in interface org.xml.sax.ContentHandler

  Throws:
    org.xml.sax.SAXException - An I/O exception occured during serializing

### startEntity

    public void startEntity(java.lang.String name)

  Specified by:
    startEntity in interface org.xml.sax.ext.LexicalHandler

### endEntity

    public void endEntity(java.lang.String name)

  Specified by:
    endEntity in interface org.xml.sax.ext.LexicalHandler

### setDocumentLocator

    public void setDocumentLocator(org.xml.sax.Locator locator)

  Specified by:
    setDocumentLocator in interface org.xml.sax.ContentHandler

### skippedEntity

    public void skippedEntity(java.lang.String name)
                       throws org.xml.sax.SAXException

  Specified by:
    skippedEntity in interface org.xml.sax.ContentHandler

### startPrefixMapping

    public void startPrefixMapping(java.lang.String prefix,
                                   java.lang.String uri)
                            throws org.xml.sax.SAXException

  Specified by:
    startPrefixMapping in interface org.xml.sax.ContentHandler

### endPrefixMapping

    public void endPrefixMapping(java.lang.String prefix)
                          throws org.xml.sax.SAXException

  Specified by:
    endPrefixMapping in interface org.xml.sax.ContentHandler

### startDTD

    public final void startDTD(java.lang.String name,
                               java.lang.String publicId,
                               java.lang.String systemId)
                        throws org.xml.sax.SAXException

  Specified by:
    startDTD in interface org.xml.sax.ext.LexicalHandler

### endDTD

    public void endDTD()

  Specified by:
    endDTD in interface org.xml.sax.ext.LexicalHandler

### elementDecl

    public void elementDecl(java.lang.String name,
                            java.lang.String model)
                     throws org.xml.sax.SAXException

  Specified by:
    elementDecl in interface org.xml.sax.ext.DeclHandler

### attributeDecl

    public void attributeDecl(java.lang.String eName,
                              java.lang.String aName,
                              java.lang.String type,
                              java.lang.String valueDefault,
                              java.lang.String value)
                       throws org.xml.sax.SAXException

  Specified by:
    attributeDecl in interface org.xml.sax.ext.DeclHandler

### internalEntityDecl

    public void internalEntityDecl(java.lang.String name,
                                   java.lang.String value)
                            throws org.xml.sax.SAXException

  Specified by:
    internalEntityDecl in interface org.xml.sax.ext.DeclHandler

### externalEntityDecl

    public void externalEntityDecl(java.lang.String name,
                                   java.lang.String publicId,
                                   java.lang.String systemId)
                            throws org.xml.sax.SAXException

  Specified by:
    externalEntityDecl in interface org.xml.sax.ext.DeclHandler

### unparsedEntityDecl

    public void unparsedEntityDecl(java.lang.String name,
                                   java.lang.String publicId,
                                   java.lang.String systemId,
                                   java.lang.String notationName)
                            throws org.xml.sax.SAXException

  Specified by:
    unparsedEntityDecl in interface org.xml.sax.DTDHandler

### notationDecl

    public void notationDecl(java.lang.String name,
                             java.lang.String publicId,
                             java.lang.String systemId)
                      throws org.xml.sax.SAXException

  Specified by:
    notationDecl in interface org.xml.sax.DTDHandler

### serializeNode

    protected void serializeNode(org.w3c.dom.Node node)
                          throws java.io.IOException

  Serialize the DOM node. This method is shared across XML, HTML and XHTML serializers and the differences are masked out in a separate `serializeElement(org.w3c.dom.Element)`.

  Parameters:
    `node` - The node to serialize
  Throws:
    java.io.IOException - An I/O exception occured while serializing
  See Also:
    `serializeElement(org.w3c.dom.Element)`

### content

    protected ElementState content()
                            throws java.io.IOException

  Must be called by a method about to print any type of content. If the element was just opened, the opening tag is closed and will be matched to a closing tag. Returns the current element state with `empty` and `afterElement` set to false.

  Returns:
    The current element state
  Throws:
    java.io.IOException - An I/O exception occured while serializing

### characters

    protected void characters(java.lang.String text)
                       throws java.io.IOException

  Called to print the text contents in the prevailing element format. Since this method is capable of printing text as CDATA, it is used for that purpose as well. White space handling is determined by the current element state. In addition, the output format can dictate whether the text is printed as CDATA or unescaped.

  Parameters:
    `text` - The text to print
    `unescaped` - True is should print unescaped
  Throws:
    java.io.IOException - An I/O exception occured while serializing

### getEntityRef

    protected abstract java.lang.String getEntityRef(int ch)

  Returns the suitable entity reference for this character value, or null if no such entity exists. Calling this method with `'&'` will return `"&amp;"`.

  Parameters:
    `ch` - Character value
  Returns:
    Character entity name, or null

### serializeElement

    protected abstract void serializeElement(org.w3c.dom.Element elem)
                                      throws java.io.IOException

  Called to serializee the DOM element. The element is serialized based on the serializer's method (XML, HTML, XHTML).

  Parameters:
    `elem` - The element to serialize
  Throws:
    java.io.IOException - An I/O exception occured while serializing

### serializePreRoot

    protected void serializePreRoot()
                             throws java.io.IOException

  Comments and PIs cannot be serialized before the root element, because the root element serializes the document type, which generally comes first. Instead such PIs and comments are accumulated inside a vector and serialized by calling this method. Will be called when the root element is serialized and when the document finished serializing.

  Throws:
    java.io.IOException - An I/O exception occured while serializing

### printCDATAText

    protected final void printCDATAText(java.lang.String text)
                                 throws java.io.IOException

### surrogates

    protected final void surrogates(int high,
                                    int low)
                             throws java.io.IOException

### printText

    protected void printText(char[] chars,
                             int start,
                             int length,
                             boolean preserveSpace,
                             boolean unescaped)
                      throws java.io.IOException

  Called to print additional text with whitespace handling. If spaces are preserved, the text is printed as if by calling `printText(String,boolean,boolean)` with a call to `Printer.breakLine()` for each new line. If spaces are not preserved, the text is broken at space boundaries if longer than the line width; Multiple spaces are printed as such, but spaces at beginning of line are removed.

  Parameters:
    `text` - The text to print
    `preserveSpace` - Space preserving flag
    `unescaped` - Print unescaped

### printText

    protected void printText(java.lang.String text,
                             boolean preserveSpace,
                             boolean unescaped)
                      throws java.io.IOException

### printDoctypeURL

    protected void printDoctypeURL(java.lang.String url)
                            throws java.io.IOException

  Print a document type public or system identifier URL. Encapsulates the URL in double quotes, escapes non-printing characters and print it equivalent to `printText(char[], int, int, boolean, boolean)`.

  Parameters:
    `url` - The document type url to print

### printEscaped

    protected void printEscaped(int ch)
                         throws java.io.IOException

### printEscaped

    protected void printEscaped(java.lang.String source)
                         throws java.io.IOException

  Escapes a string so it may be printed as text content or attribute value. Non printable characters are escaped using character references. Where the format specifies a deault entity reference, that reference is used (e.g. `&lt;`).

  Parameters:
    `source` - The string to escape

### getElementState

    protected ElementState getElementState()

  Return the state of the current element.

  Returns:
    Current element state

### enterElementState

    protected ElementState enterElementState(java.lang.String namespaceURI,
                                             java.lang.String localName,
                                             java.lang.String rawName,
                                             boolean preserveSpace)

  Enter a new element state for the specified element. Tag name and space preserving is specified, element state is initially empty.

  Returns:
    Current element state, or null

### leaveElementState

    protected ElementState leaveElementState()

  Leave the current element state and return to the state of the parent element. If this was the root element, return to the state of the document.

  Returns:
    Previous element state

### isDocumentState

    protected boolean isDocumentState()

  Returns true if in the state of the document. Returns true before entering any element and after leaving the root element.

  Returns:
    True if in the state of the document

### getPrefix

    protected java.lang.String getPrefix(java.lang.String namespaceURI)

  Returns the namespace prefix for the specified URI. If the URI has been mapped to a prefix, returns the prefix, otherwise returns null.

  Parameters:
    `namespaceURI` - The namespace URI
  Returns:
    The namespace prefix if known, or null

### modifyDOMError

    protected org.apache.xerces.dom3.DOMError modifyDOMError(java.lang.String message,
                                                             short severity,
                                                             org.w3c.dom.Node node)

  The method modifies global DOM error object

  Parameters:
    `message` -
    `severity` -
  Returns:
    a DOMError

### fatalError

    protected void fatalError(java.lang.String message)
                       throws java.io.IOException

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Documentation is available at http://e-docs.bea.com/wls/docs81
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD